;=======================================================================
include "8085.inc"
include "rks.inc"
;include "shownum.inc"
;include "bv.inc"
;=======================================================================
    RKS_START 0
;-----------------------------------------------------------------------
    call 0C010h ; clear the screen
;-----------------------------------------------------------------------
    lxi d,i8080 ; print big string "I8080..."
    call big_str6
;-----------------------------------------------------------------------
    lxi h,65535
    call delay
;-----------------------------------------------------------------------
    lxi h,9080h ; set position for big string and print a new one
    shld big_char6.curr
    lxi d,zar
    call big_str6
;-----------------------------------------------------------------------
    lxi h,65535
    call delay
;-----------------------------------------------------------------------
    lxi h,9000h ; smooth clear the screen
    lxi d,0C0FEh    
    call fade
;-----------------------------------------------------------------------
    mvi a,-1
    sta draw_line.color
    lxi h,25
    shld draw_line.x_1
    lxi h,125
    shld draw_line.x_2
    lxi h,35
    shld draw_line.y_1
    lxi h,170
    shld draw_line.y_2
    call draw_rect
;-----------------------------------------------------------------------
    lxi h,150
    lxi d,250
    lxi b,100
    mvi a,1
    call circle
;-----------------------------------------------------------------------
    lxi h,100
    lxi d,200
    lxi b,25
    mvi a,0
    call circle
;-----------------------------------------------------------------------
    lxi h,100
    lxi d,125
    lxi b,75
    mvi a,-1
    sta draw_arc.color
    mvi a,0FFh
    call draw_arc
;-----------------------------------------------------------------------
    lxi h,150
    lxi d,150
    lxi b,100
    mvi a,0C3h
    call draw_arc
;-----------------------------------------------------------------------
    lxi h,300
    lxi d,200
    lxi b,200
    mvi a,0F0h
    call draw_arc
;-----------------------------------------------------------------------
    lxi h,50
    lxi d,152
    lxi b,250
    mvi a,-1
    call vert_line
;-----------------------------------------------------------------------
    lxi h,150
    lxi d,50
    lxi b,250
    mvi a,-1
    call hor_line
;-----------------------------------------------------------------------
    mvi a,-1
    sta draw_line.color
    lxi h,0
    shld draw_line.x_1
    lxi h,383
    shld draw_line.x_2
    lxi h,0
    shld draw_line.y_1
    lxi h,255
    shld draw_line.y_2
    call draw_line
;-----------------------------------------------------------------------
draw_sinusoid:     ; draw sinusoid line
    lhld xx
    inx h
    shld xx
    dad h
    lxi b,127
    call mulsin
    xchg
    lhld yy
    dad d
    xchg
    lhld xx
    xchg
    lda kk
    mov c,a
    call put_pixel
    lda ll
    sui 1
    sta ll
    lda ll+1
    sbi 0
    sta ll+1
    jnc draw_sinusoid 
;-----------------------------------------------------------------------
    lxi h,50 ; print "fasm" in vector mode
    lxi d,50
    lxi b,fasm1
    mvi a,-1
    call draw
;-----------------------------------------------------------------------
    lxi h,-1
    call delay
;-----------------------------------------------------------------------
    lxi h,9000h
    lxi d,0C0FEh    
    call fade
;-----------------------------------------------------------------------
f:
    mvi a,1 ; print "fahiwec" in vector mode 
    sta draw_line.color
    lxi b,specl
.m1:
    ldax b
    inx b
    cpi -1
    jz  .m2
    mov e,a
    ldax b
    inx b
    mov d,a
    lhld specx0
    dad d
    shld draw_line.x_1
    ldax b
    inx b
    mov e,a
    ldax b
    inx b
    mov d,a
    lhld specy0
    dad d
    shld draw_line.y_1
    ldax b
    inx b
    mov e,a
    ldax b
    inx b
    mov d,a
    lhld specx0
    dad d
    shld draw_line.x_2
    ldax b
    inx b
    mov e,a
    ldax b
    inx b
    mov d,a
    lhld specy0
    dad d
    shld draw_line.y_2
    push b
    call draw_line
    pop b
    jmp .m1
.m2:   
    mvi a,1
    sta draw_arc.color
    lxi h,speca
.m3:
    mov a,m
    inx h
    cpi -1
    jz  .m4
    mov e,a
    mov a,m
    inx h
    mov d,a
    push h
    lhld specx0
    dad d
    xthl
    mov a,m
    inx h
    mov e,a
    mov a,m
    inx h
    mov d,a
    push h
    lhld specy0
    dad d
    xchg
    pop h
    mov a,m
    inx h
    mov c,a
    mov a,m
    inx h
    mov b,a
    mov a,m
    inx h
    inx h
    xthl
    xchg
    call draw_arc
    pop h
    jmp .m3
.m4:         
;-----------------------------------------------------------------------
    lxi h,9A80h
    shld big_char6.curr
    lxi d,R2016
    call big_str6
;-----------------------------------------------------------------------
    jmp $ 
;-----------------------------------------------------------------------
;    ret    
;-----------------------------------------------------------------------
yy: dw 127
xx: dw -1
kk: db -1
ll: dw 384
;-----------------------------------------------------------------------
i8080:
    db " I8080A",13
    db "580wm80a"
    db " POWERED"
    db "BY FASMG",0
zar:
    db "zarqveno"
    db "fasmom G",0  
    
R2016:
    db "2016",0      
;-----------------------------------------------------------------------
fasm1:
    db 1 ; F
    db 46,0,16,2,32,4,16,2,32,0,16,2,32,4,32,2,16,4,76,6
    db 0
;-----------------------------------------------------------------------
    db 2
    dw 64,76
;-----------------------------------------------------------------------
    db 1 ; A
    db 62,6,16,7,16,0,16,1,62,2,16,4,32,6,16,4,32,2,16,4
    db 0
;-----------------------------------------------------------------------
    db 2
    dw 15,-45
;-----------------------------------------------------------------------
    db 1
    db 16,6,16,0,16,2,16,4
    db 0
;-----------------------------------------------------------------------
    db 2
    dw 48,24
;-----------------------------------------------------------------------
    db 1 ; S
    db 16,0,8,2,16,0,18,6,24,4,8,5,32,6,8,7,32,0,8,1,16,2
    db 16,4,8,6,16,4,16,2,24,0,8,1,34,2,8,3,32,4,8,5,16,6
    db 0
;-----------------------------------------------------------------------
    db 2
    dw 64,22
;-----------------------------------------------------------------------
    db 1 ; M
    db 78,6,16,0,16,1,16,7,16,0,78,2,16,4,60,6,16,3,16,5,60,2,16,4
    db 0
;-----------------------------------------------------------------------
    db 0        
;-----------------------------------------------------------------------
specx0: dw 10
specy0: dw 32
    
specl:
    dw  20,  0, 30,  0 ; 
    dw  20,  0, 20, 10
    dw  30,  0, 30, 10
    dw  20, 20, 20, 40
    dw  20, 50, 20, 60                    
    dw  30, 20, 30, 40
    dw  30, 50, 30, 60 
    dw  20, 60, 30, 60
    
    dw  65,  0, 50, 60 ; 
    dw  65,  0, 75,  0
    dw  75,  0, 90, 60
    dw  90, 60, 80, 60
    dw  60, 60, 50, 60
    dw  60, 60, 64, 40
    dw  64, 40, 76, 40
    dw  76, 40, 80, 60
    dw  66, 30, 69, 15
    dw  69, 15, 73, 30
    dw  73, 30, 66, 30
    
    dw 100,  0,115, 30 ; 
    dw 115, 30,100, 60
    dw 100, 60,110, 60
    dw 110, 60,120, 40
    dw 120, 40,130, 60
    dw 130, 60,140, 60
    dw 140, 60,125, 30
    dw 125, 30,140,  0 
    dw 140,  0,130,  0
    dw 130,  0,120, 20
    dw 120, 20,110,  0
    dw 110,  0,100,  0
    
    dw 150,  0,150, 60 ; 
    dw 150, 60,160, 60
    dw 160, 60,160,  0
    dw 160,  0,150,  0
    
    dw 170,  0,170, 60 ; 
    dw 170, 60,190, 60
    dw 170,  0,190,  0
    dw 180, 10,180, 26
    dw 180, 34,180, 50
    dw 190, 34,180, 34
    dw 190, 26,180, 26
    dw 180, 10,190, 10
    dw 180, 50,190, 50
    
    dw 220,  0,260,  0 ; 
    dw 260,  0,260, 10
    dw 260, 10,230, 10
    dw 230, 10,230, 25
    dw 230, 25,250, 25
    dw 250, 25,250, 35
    dw 250, 35,230, 35
    dw 230, 35,230, 50
    dw 230, 50,260, 50
    dw 260, 50,260, 60
    dw 260, 60,220, 60
    dw 220, 60,220,  0

    dw 270,  0,280,  0 ; 
    dw 280,  0,280, 50
    dw 280, 50,300, 50
    dw 300, 50,300,  0
    dw 300,  0,310,  0
    dw 310,  0,310, 50
    dw 310, 50,315, 50
    dw 315, 50,305, 70
    dw 305, 70,300, 70
    dw 300, 70,300, 60
    dw 300, 60,270, 60
    dw 270, 60,270,  0
    
    dw 340, 20,330, 20 ; 
    dw 330, 20,330,  0
    dw 330,  0,320,  0
    dw 320,  0,320, 60
    dw 320, 60,340, 60
    dw 340, 30,330, 30
    dw 330, 30,330, 50
    dw 330, 50,340, 50

    dw  -1
    
speca:
    dw  20, 30,10,03Ch ; 
    dw  20, 30,20,03Ch
    dw  30, 30,10,0C3h
    dw  30, 30,20,0C3h
    
    dw 190, 18,18,0C1h ; 
    dw 190, 42,18,083h
    dw 190, 18, 8,0C3h
    dw 190, 42, 8,0C3h
    
    dw 340, 40,10,0C3h ; 
    dw 340, 40,20,0C3h
    
    dw  -1                   
;-----------------------------------------------------------------------
include "graf.inc"
include "math.inc"
include "big_char.inc"
;-----------------------------------------------------------------------
    RKS_END
;=======================================================================
            